<?php
defined('CONF_URL_APP') or die;

class CampNewsletter extends ItemModel
{
	protected $dbt_const = "DBT_NEWSLETTER";
	protected $dbt = "newsletter";
	
	protected $ext_folder = "ext_newsletter";
	protected $ext_vista_categoria = "lista_newsletter";
	protected $ext_vista_item = "newsletter";
	
	protected $ext_item_class = "CampNewsletter";
	protected $ext_categoria_class = "ListaNewsletter";
	protected $ext_item_campoextra_class = "CampNewsletterCampoExtra";
	
	protected $all_vars = array("id","titulo","alias","contenido","fecha","fecha_publicacion","estado","imagen_destacada","categorias","creador","creador_alias","propietario","params","tags","idioma","lugar","direccion","codigo_postal","localidad","provincia","pais","latitud","longitud","acceso","id_original");
	
	protected $idx_vars = array("id");
	protected $update_vars = array("titulo","alias","contenido","fecha_publicacion","estado","imagen_destacada","categorias","creador","creador_alias","propietario","params","tags","idioma","lugar","direccion","codigo_postal","localidad","provincia","pais","latitud","longitud","acceso","id_original");
	
	protected $campos_multilang = array("titulo","alias","contenido","lugar");
	protected $campos_array = array("params","categorias");
	
	function __construct(){
		parent::__construct();
	}
	
	function includes(){
		c_include('loc/region','loc/provincia','loc/localidad','loc/pais');
		e_include('ext_newsletter/class/listaNewsletter','ext_newsletter/class/usuarioNewsletter');
	}
	
	function getUsuariosNewsletter($solo_activos=true, $where='', $orden='', $ordenDir='', $limit1=0, $limit2=0){
		e_include('ext_newsletter/class/usuarioNewsletter');
		
		if (!empty($where)){
			$where .= ' AND artista='.$this->id;
			if ($solo_activos == true){
				$where .= ' AND estado=1';
			}
		} else {
			$where = 'artista='.$this->id;
			if ($solo_activos == true){
				$where .= ' AND estado=1';
			}
			
		}
		
		$usuarios_newsletter = new UsuarioNewsletter();
		$usuarios_newsletter_count = $usuarios_newsletter->ListarCount($where, $orden, $ordenDir);
		if ($usuarios_newsletter_count > 0){
			$usuarios_newsletter = $usuarios_newsletter->Listar($where, $orden, $ordenDir);
			
			$arr_usrs = array();
			
			$tmp_id = trim($this->id);
			
			foreach ($usuarios_newsletter as $alb){
				$arr_usrs[] = $alb;
			}
			
			if ($limit2 > 0){
				$arr_usrs = array_slice($arr_usrs, $limit1, $limit2);
			}
			
			if (empty($arr_usrs))
				return false;
			else
				return $arr_usrs;
		} else {
			return false;
		}
	}


	public static function get_num_usuarios_newsletter($filtro=''){
		$num_art = new self();
		
		$num_art = $num_art->ListarCount($filtro);
		
		return $num_art;
	}
	
}
?>