<?php
/**
 * Api class for the Mideas Framework.
 *
 * @package		Mideas.Framework
 * @subpackage	Api
 * @since		1.0
 */
//e_include('ext_comentarios/class/extComAdaptador');

class HelperMotorNewsletter
{
	protected $motores_disponibles;
	
	public function __construct(){
		$this->getMotoresDisponibles();
	}
	
	public function getCurrentMotor(){
		$motor_actual = $GLOBALS["opciones"]["ext_newsletter"]["general"]["motor"];
		
		if (empty($motor_actual))
			return false;
			
		return $this->getMotor($motor_actual);
	}
	
	public function getMotor($id_motor){
		if (empty($id_motor))
			return false;
			
		if (empty($this->motores_disponibles))
			$this->getMotoresDisponibles();
			
		if (empty($this->motores_disponibles))
			return false;
			
		if (array_key_exists($id_motor, $this->motores_disponibles)){
			return $this->motores_disponibles[$id_motor];
		} else {
			return false;
		}
	}
		
	public function getMotoresDisponibles($forceReload=false){
		if (empty($this->motores_disponibles) || $forceReload == true){
			$dir_motores = dirname(__FILE__) . '/motores/';

			$dir_list = Helpers::dir_list($dir_motores, '','class.php');
			
			$arr_dir = $dir_list[substr($dir_motores,0,-1)];
			
			$results = array();
			
			if (is_array($arr_dir) && sizeof($arr_dir) > 0){
				
				foreach ($arr_dir as $file){
					$filename = substr($file, 0, -10);
					
					$class_nombre = ucfirst($filename) . "MotorNewsletter";
					
					if (!is_file($dir_motores . $filename .'.class.php')){
						continue;
					}
					
					if (!class_exists($class_nombre)){
						include($dir_motores . $filename .'.class.php');
					}
					
					if (!class_exists($class_nombre)){
						continue;
					}
					
					$tmp_clase = new $class_nombre();
					
					$id_clase = $tmp_clase->getId();
					
					if (!array_key_exists($id_clase, $this->motores_disponibles)){
						$this->motores_disponibles[$id_clase] = $tmp_clase;
					}
				}
				
				return $this->motores_disponibles;
			} else {
				return false;
			}
		} else {
			return $this->motores_disponibles;
		}
	}
}