SET FOREIGN_KEY_CHECKS=0;

-- --------------------------------------------------------

-- 
-- Estructura de tabla para la tabla `#__newsletter`
-- 

DROP TABLE IF EXISTS `#__newsletter`;
CREATE TABLE IF NOT EXISTS `#__newsletter` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `titulo` varchar(250) NOT NULL DEFAULT '',
  `alias` varchar(250) NOT NULL,
  `contenido` text NOT NULL,
  `imagen_destacada` text NOT NULL,
  `fecha` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `fecha_publicacion` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  `estado` int(1) NOT NULL DEFAULT '1',
  `categorias` text NOT NULL,
  `params` text NOT NULL,
  `creador` int(11) NOT NULL,
  `creador_alias` varchar(250) NOT NULL DEFAULT '',
  `propietario` int(11) NOT NULL DEFAULT '0',
  `lugar` text NOT NULL,
  `direccion` text NOT NULL,
  `codigo_postal` text NOT NULL,
  `pais` varchar(2) NOT NULL,
  `provincia` int(11) NOT NULL,
  `localidad` int(11) NOT NULL,
  `idioma` varchar(2) NOT NULL,
  `latitud` text NOT NULL,
  `longitud` text NOT NULL,
  `acceso` int(11) NOT NULL DEFAULT '0',
  `tags` text NOT NULL,
  `id_original` int(11) NOT NULL DEFAULT '0',
  `location` point NOT NULL,
  PRIMARY KEY (`id`),
  SPATIAL KEY `location` (`location`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC;

-- --------------------------------------------------------

-- 
-- Estructura de tabla para la tabla `#__newsletter_listas`
-- 

DROP TABLE IF EXISTS `#__newsletter_listas`;
CREATE TABLE IF NOT EXISTS `#__newsletter_listas` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `nombre` varchar(250) NOT NULL DEFAULT '',
  `alias` varchar(250) NOT NULL,
  `contenido` text NOT NULL,
  `fecha` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `estado` int(1) NOT NULL DEFAULT '1',
  `padre` varchar(250) NOT NULL DEFAULT '',
  `creador` int(11) NOT NULL,
  `creador_alias` varchar(250) NOT NULL DEFAULT '',
  `params` text,
  `imagen_destacada` text NOT NULL,
  `icono` text NOT NULL,
  `idioma` varchar(5) NOT NULL,
  `acceso` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

-- 
-- Estructura de tabla para la tabla `#__newsletter_usuarios`
-- 

DROP TABLE IF EXISTS `#__newsletter_usuarios`;
CREATE TABLE IF NOT EXISTS `#__newsletter_usuarios` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `nombre` text NOT NULL,
  `email` text NOT NULL,
  `fecha` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `estado` int(1) NOT NULL DEFAULT '1',
  `formato` varchar(100) NOT NULL,
  `listas` text NOT NULL,
  `acepta_emails` int(1) NOT NULL DEFAULT '1',
  `ip` varchar(250) NOT NULL DEFAULT '',
  `params` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

SET FOREIGN_KEY_CHECKS=1;