<?php
class Newsletter extends Controller
{
	protected $ext_folder = 'ext_newsletter';
	protected $ext_home_vista = 'home';
	protected $ext_categoria_vista = 'lista_newsletter';
	protected $ext_item_vista = 'newsletter';
	protected $ext_form_item_vista = 'nuevo_newsletter';
	
	protected $ext_item_modelo = 'CampNewsletterModel';
	protected $ext_categoria_modelo = 'ListaNewsletterModel';
	protected $ext_home_modelo = 'HomeNewsletterModel';
	
	protected $ext_categoria_clase = 'ListaNewsletter';
	protected $ext_item_clase = 'CampNewsletter';
	
	var $extra_vistas_categoria=array("usuarios_newsletter"=>"ListaNewsletter");
	var $extra_vistas_items=array("usuario_newsletter"=>"UsuarioNewsletter");
	
	var $artista;
	
	function __construct(){
		parent::__construct();
	}
	
	public function includes(){
		c_include('loc/region','loc/provincia','loc/localidad','loc/pais');
		e_include('ext_newsletter/class/campNewsletter','ext_newsletter/class/listaNewsletter');
		e_include('ext_newsletter/models/campNewsletter','ext_newsletter/models/listaNewsletter','ext_newsletter/models/home');
		if (!class_exists('CampNewsletter') || !class_exists('ListaNewsletter')) {
			App::setMsg(__("Error 500: No se ha encontrado la clase de la extensión."), 'error');
			return false;
		}
	}
	
	public function get_params_url_vars($num_url_vars){
		
		$params = array();
		
		$params_ext = $GLOBALS["opciones"][$this->ext_folder];
		
		if ($params_ext['general']['geolocalizacion_en_url'] == '1'){
		
			switch($num_url_vars){
				case 1:
					if ($_GET['vista'] == 'usuarios_newsletter'){
						$subcategoria = $this->encuentra_subcategoria_por_nombre($this->url_vars[0]);
						if (!empty($subcategoria)){
							$params['categoria'] = $subcategoria;
							$this->get_vars['subcategoria'] = $this->url_vars[0];
							
							$_GET['vista'] = 'usuarios_newsletter';
							$_GET['id'] = $subcategoria;
							$_GET['estilo'] = '';
						} else {
							$item = $this->encuentra_usuario_newsletter_por_nombre($this->url_vars[0]);
							if (!empty($item)){
								$params['usuario_newsletter'] = $item;
								
								$_GET['vista'] = 'usuario_newsletter';
								$_GET['id'] = $item;
								$_GET['estilo'] = '';
							} else {
								break;
							}
							
							$continuar_filtro = false;
							if ((is_array($GLOBALS["opciones"][$this->ext_folder]["general"]) && in_array($this->url_vars[0], $GLOBALS["opciones"][$this->ext_folder]["general"]["paises_permitidos"])) || (empty($GLOBALS["opciones"][$this->ext_folder]["general"]["paises_permitidos"]))){
								$continuar_filtro = true;
							}
							
							if ($continuar_filtro){
					
								$pais_obj = Pais::BuscarPorISO2($this->url_vars[0]);
								
								if (is_object($pais_obj)){
									$this->get_vars['pais'] = $pais_obj->iso2;
									
									$this->pais_obj = $pais_obj;
								} else {
									break;
								}
							
							}
						}
					}
					break;	
				
				case 2:
					if ($_GET['vista'] == 'usuarios_newsletter'){
						$subcategoria = $this->encuentra_subcategoria_por_nombre($this->url_vars[0]);
						if (!empty($subcategoria)){
							$params['categoria'] = $subcategoria;
							$this->get_vars['subcategoria'] = $this->url_vars[0];
							
							$_GET['vista'] = 'usuarios_newsletter';
							$_GET['id'] = $subcategoria;
							$_GET['estilo'] = '';
							
							$pais_obj = Pais::BuscarPorISO2($this->url_vars[1]);
						
							if (is_object($pais_obj)){
								$this->get_vars['pais'] = $pais_obj->iso2;
								
								$this->pais_obj = $pais_obj;
							} else {
								break;
							}
						} else {
							$pais_obj = Pais::BuscarPorISO2($this->url_vars[0]);
						
							if (is_object($pais_obj)){
								$this->get_vars['pais'] = $pais_obj->iso2;
								
								$this->pais_obj = $pais_obj;
								
								$prov_obj = Provincia::BuscarAlias($this->url_vars[1],$this->url_vars[0]);
								
								if (is_object($prov_obj)){
									$this->get_vars['provincia'] = $prov_obj->getalias();
									
									$this->provincia_obj = $prov_obj;
								} else {
									break;
								}
							} else {
								break;
							}
						}
					}
					break;
					
				case 3:
					if ($_GET['vista'] == 'usuarios_newsletter'){
						$subcategoria = $this->encuentra_subcategoria_por_nombre($this->url_vars[0]);
						if (!empty($subcategoria)){
							$params['categoria'] = $subcategoria;
							$this->get_vars['subcategoria'] = $this->url_vars[0];
							
							$_GET['vista'] = 'usuarios_newsletter';
							$_GET['id'] = $subcategoria;
							$_GET['estilo'] = '';
				
							$pais_obj = Pais::BuscarPorISO2($this->url_vars[1]);
							
							if (is_object($pais_obj)){
								$this->get_vars['pais'] = $pais_obj->iso2;
								
								$this->pais_obj = $pais_obj;
								
								$prov_obj = Provincia::BuscarAlias($this->url_vars[2],$this->url_vars[1]);
								
								if (is_object($prov_obj)){
									$this->get_vars['provincia'] = $prov_obj->getalias();
									
									$this->provincia_obj = $prov_obj;
								} else {
									break;
								}
							} else {
								break;
							}
						} else {
							$pais_obj = Pais::BuscarPorISO2($this->url_vars[0]);
						
							if (is_object($pais_obj)){
								$this->get_vars['pais'] = $pais_obj->iso2;
								
								$this->pais_obj = $pais_obj;
								
								$prov_obj = Provincia::BuscarAlias($this->url_vars[1],$this->url_vars[0]);
								
								if (is_object($prov_obj)){
									$this->get_vars['provincia'] = $prov_obj->getalias();
									
									$this->provincia_obj = $prov_obj;
									
									$loc_obj = Localidad::BuscarAlias($this->url_vars[2], $prov_obj->id);
									
									if (is_object($loc_obj)){
										$this->get_vars['localidad'] = $loc_obj->getalias();
										
										$this->localidad_obj = $loc_obj;
									}
								} else {
									break;
								}
							} else {
								break;
							}
						}
					}
					break;
					
				case 4:
					if ($_GET['vista'] == 'usuarios_newsletter'){
						$item = $this->encuentra_usuario_newsletter_por_nombre($this->url_vars[3],$this->url_vars[2],$this->url_vars[1],$this->url_vars[0]);
						if (!empty($item)){
							$params['usuario_newsletter'] = $item;
							
							$_GET['vista'] = 'usuario_newsletter';
							$_GET['id'] = $item;
							$_GET['estilo'] = '';
						}
						
						$subcategoria = $this->encuentra_subcategoria_por_nombre($this->url_vars[0]);
						if (!empty($subcategoria)){
							$params['categoria'] = $subcategoria;
							$this->get_vars['subcategoria'] = $this->url_vars[0];
							
							$_GET['vista'] = 'usuarios_newsletter';
							$_GET['id'] = $subcategoria;
							$_GET['estilo'] = '';
		
							$pais_obj = Pais::BuscarPorISO2($this->url_vars[1]);
							
							if (is_object($pais_obj)){
								$this->get_vars['pais'] = $pais_obj->iso2;
								
								$this->pais_obj = $pais_obj;
								
								$prov_obj = Provincia::BuscarAlias($this->url_vars[2],$this->url_vars[1]);
								
								if (is_object($prov_obj)){
									$this->get_vars['provincia'] = $prov_obj->getalias();
									
									$this->provincia_obj = $prov_obj;
									
									$loc_obj = Localidad::BuscarAlias($this->url_vars[3], $prov_obj->id);
									
									if (is_object($loc_obj)){
										$this->get_vars['localidad'] = $loc_obj->getalias();
										
										$this->localidad_obj = $loc_obj;
									} else {
										break;
									}
								} else {
									break;
								}
							}
						} else {
							$pais_obj = Pais::BuscarPorISO2($this->url_vars[0]);
							
							if (is_object($pais_obj)){
								$this->get_vars['pais'] = $pais_obj->iso2;
								
								$this->pais_obj = $pais_obj;
								
								$prov_obj = Provincia::BuscarAlias($this->url_vars[1],$this->url_vars[0]);
								
								if (is_object($prov_obj)){
									$this->get_vars['provincia'] = $prov_obj->getalias();
									
									$this->provincia_obj = $prov_obj;
									
									$loc_obj = Localidad::BuscarAlias($this->url_vars[2], $prov_obj->id);
									
									if (is_object($loc_obj)){
										$this->get_vars['localidad'] = $loc_obj->getalias();
										
										$this->localidad_obj = $loc_obj;
									} else {
										break;
									}
								} else {
									break;
								}
							} else {
								break;
							}
						}
					}
					break;
				case 5:
					if ($_GET['vista'] == 'usuarios_newsletter'){
						$subcategoria = $this->encuentra_subcategoria_por_nombre($this->url_vars[0]);
						if ($subcategoria){
							$this->get_vars['subcategoria'] = $this->url_vars[0];
							$item = $this->encuentra_usuario_newsletter_por_nombre($this->url_vars[4],$this->url_vars[3],$this->url_vars[2],$this->url_vars[1],$subcategoria);
							if (!empty($item)){
								$params['usuario_newsletter'] = $item;
								
								$_GET['vista'] = 'usuario_newsletter';
								$_GET['id'] = $item;
								$_GET['estilo'] = '';
							} else {
								echo App::printErrorPage('404', __('La página no existe'));
								exit;
							}
						} else {
							break;
						}
				
						$pais_obj = Pais::BuscarPorISO2($this->url_vars[1]);
						
						if (is_object($pais_obj)){
							$this->get_vars['pais'] = $pais_obj->iso2;
							
							$this->pais_obj = $pais_obj;
							
							$prov_obj = Provincia::BuscarAlias($this->url_vars[2],$this->url_vars[1]);
							
							if (is_object($prov_obj)){
								$this->get_vars['provincia'] = $prov_obj->getalias();
								
								$this->provincia_obj = $prov_obj;
								
								$loc_obj = Localidad::BuscarAlias($this->url_vars[3], $prov_obj->id);
								
								if (is_object($loc_obj)){
									$this->get_vars['localidad'] = $loc_obj->getalias();
									
									$this->localidad_obj = $loc_obj;
								} else {
									break;
								}
							} else {
								break;
							}
						}
					}
					break;
			}
		
		} else {
			switch($num_url_vars){
				case 1:
					if ($_GET['vista'] == 'usuarios_newsletter'){
						$subcategoria = $this->encuentra_subcategoria_por_nombre($this->url_vars[0]);
						if (!empty($subcategoria)){
							$this->get_vars['subcategoria'] = $this->url_vars[0];
							$params['categoria'] = $subcategoria;
							
							$_GET['vista'] = 'usuarios_newsletter';
							$_GET['id'] = $subcategoria;
							$_GET['estilo'] = '';
						} else {
							$item = $this->encuentra_usuario_newsletter_por_nombre_sinloc($this->url_vars[0]);
							if (!empty($item)){
								$params['usuario_newsletter'] = $item;
								
								$_GET['vista'] = 'usuario_newsletter';
								$_GET['id'] = $item;
								$_GET['estilo'] = '';
							} else {
								echo App::printErrorPage('404', __('La página no existe'));
								exit;
							}
						}
					}
					break;
					
				case 2:
					if ($_GET['vista'] == 'usuarios_newsletter'){
						$subcategoria = $this->encuentra_subcategoria_por_nombre($this->url_vars[0]);
						if (!empty($subcategoria)){
							$this->get_vars['subcategoria'] = $this->url_vars[0];
							$params['categoria'] = $subcategoria;
							
							$item = $this->encuentra_usuario_newsletter_por_nombre_sinloc($this->url_vars[2], $this->url_vars[1], $subcategoria);
							if (!empty($item)){
								$params['usuario_newsletter'] = $item;
								
								$_GET['vista'] = 'usuario_newsletter';
								$_GET['id'] = $item;
								$_GET['estilo'] = '';
							} else {
								$_GET['vista'] = 'usuarios_newsletter';
								$_GET['id'] = $subcategoria;
								$_GET['estilo'] = '';
							}
						} else {
							$item = $this->encuentra_usuario_newsletter_por_nombre_sinloc($this->url_vars[1],$this->url_vars[0]);
							if (!empty($item)){
								$params['usuario_newsletter'] = $item;
								
								$_GET['vista'] = 'usuario_newsletter';
								$_GET['id'] = $item;
								$_GET['estilo'] = '';
							} else {
								echo App::printErrorPage('404', __('La página no existe'));
								exit;
							}
						}
					}
					break;
				case 3:
					if ($_GET['vista'] == 'usuarios_newsletter'){
						$subcategoria = $this->encuentra_subcategoria_por_nombre($this->url_vars[0]);

						if ($subcategoria){
							$this->get_vars['subcategoria'] = $this->url_vars[0];
							$item = $this->encuentra_usuario_newsletter_por_nombre_sinloc($this->url_vars[2],$this->url_vars[1], $subcategoria);
							if (!empty($item)){
								$params['usuario_newsletter'] = $item;
								
								$_GET['vista'] = 'usuario_newsletter';
								$_GET['id'] = $item;
								$_GET['estilo'] = '';
							} else {
								echo App::printErrorPage('404', __('La página no existe'));
								exit;
							}
						} else {
							echo App::printErrorPage('404', __('La página no existe'));
							exit;
						}
					}
					break;
			}
			
		}
		
		if (!is_array($params) || sizeof($params) == 0){
			$params = parent::get_params_url_vars($num_url_vars);
		}
		
		return $params;
	}
	
	function encuentra_usuario_newsletter_por_nombre_sinloc($item='',$dia='', $id_cat){
		if (empty($item) || ($_GET['vista'] != 'usuarios_newsletter' || empty($GLOBALS['enlace_actual'])))
			return false;
			
		$categoria = new ListaNewsletter();
		if (empty($id_cat))
			$id_cat = $_GET['id'];
			
		$categoria->setid($id_cat);
		if ($categoria = $categoria->BuscarId()) {
			$params_cat = $GLOBALS['params_enlace_actual'];
			$items = $categoria->getUsuariosNewsletter(true,"alias LIKE '%\"".SistemaIdioma::getIdiomaSesion()."\":\"".$item."\"%'",$params_cat['params']['orden'],$params_cat['params']['orden_dir'], 0, 0, SistemaIdioma::getIdiomaSesion(), false, false);
		} else {
			return false;
		}
		
		if ($items == false)
			return false;
			
		foreach ($items as $ite){
			if ($item == SistemaIdioma::Imprimir($ite->alias) && (empty($dia) || $dia == strftime('%Y_%m_%d',strtotime($ite->fecha)))) {
				return $ite->id;
			}
		}
	}
	
	function encuentra_usuario_newsletter_por_nombre($item='',$localidad='', $provincia='', $pais='', $id_cat){
		if (empty($item) || empty($localidad) || empty($provincia) || empty($pais) || ($_GET['vista'] != 'usuarios_newsletter' || empty($GLOBALS['enlace_actual'])))
			return false;
			
		$categoria = new ListaNewsletter();
		if (empty($id_cat))
			$id_cat = $_GET['id'];
			
		$categoria->setid($id_cat);
		if ($categoria = $categoria->BuscarId()) {
			$params_cat = $GLOBALS['params_enlace_actual'];
			$items = $categoria->getUsuariosNewsletter(true,"alias LIKE '%\"".SistemaIdioma::getIdiomaSesion()."\":\"".$item."\"%'",$params_cat['params']['orden'],$params_cat['params']['orden_dir'], 0, 0, SistemaIdioma::getIdiomaSesion(), false, false);
		} else {
			return false;
		}
		
		$pais_obj = Pais::BuscarPorISO2($pais);
		
		if (is_object($pais_obj)){
			$prov_obj = Provincia::BuscarAlias($provincia,$pais);
			
			if (is_object($prov_obj)){
				$loc_obj = Localidad::BuscarAlias($localidad, $prov_obj->id);
			}
		}
		
		if ($items == false)
			return false;
			
		foreach ($items as $ite){
			if ($item == SistemaIdioma::Imprimir($ite->alias) && (($ite->localidad == $loc_obj->id && $ite->provincia == $prov_obj->id && $ite->pais == $pais) || (!is_object($loc_obj)))) {
				return $ite->id;
			}
		}
	}
	
	function set_breadcrumbs(){
		$base_link = $this->current_url;
		Helpers::getBreadcrumbs();
		
		$params_ext = $this->config;
		
		switch ($_GET['vista']){
			case 'usuario_newsletter':
				if ($params_ext["general"]["geolocalizacion_en_url"] == '1' && $params_ext["general"]["geolocalizacion"] == '1'){
					
					if (is_object($this->pais_obj)){
						$url_pais = $this->construir_url_categoria(true, array('pais'=>$this->pais_obj->iso2, 'provincia'=>'', 'localidad'=>''),true, $base_link);
						$this->breadcrumbs[$url_pais] = $this->pais_obj->getpais();
						
						if (is_object($this->provincia_obj)){
							$url_provincia = $this->construir_url_categoria(true, array('pais'=>$this->pais_obj->iso2, 'provincia'=>$this->provincia_obj->getalias(), 'localidad'=>''),true, $base_link);
							$this->breadcrumbs[$url_provincia] = $this->provincia_obj->getprovincia();
							
							if (is_object($this->localidad_obj)){
								$url_localidad = $this->construir_url_categoria(true, array('pais'=>$this->pais_obj->iso2, 'provincia'=>$this->provincia_obj->getalias(), 'localidad'=>$this->localidad_obj->getalias()),true, $base_link);
								$this->breadcrumbs[$url_localidad] = $this->localidad_obj->getlocalidad();
							}
							
						}
					}
				} elseif ($params_ext["general"]["geolocalizacion"] == '1') {
					if ($this->pais_obj = Pais::BuscarPorISO2($this->get_vars['pais'])){
						$url_pais = $this->construir_url_categoria(true, array('pais'=>$this->pais_obj->iso2, 'provincia'=>'', 'localidad'=>''),true, $base_link);
						$this->breadcrumbs[$url_pais] = $this->pais_obj->getpais();
						
						if (is_object($this->provincia_obj)){
							$url_provincia = $this->construir_url_categoria(true, array('pais'=>$this->pais_obj->iso2, 'provincia'=>$this->provincia_obj->getalias(), 'localidad'=>''),true, $base_link);
							$this->breadcrumbs[$url_provincia] = $this->provincia_obj->getprovincia();
							
							if (is_object($this->localidad_obj)){
								$url_localidad = $this->construir_url_categoria(true, array('pais'=>$this->pais_obj->iso2, 'provincia'=>$this->provincia_obj->getalias(), 'localidad'=>$this->localidad_obj->getalias()),true, $base_link);
								$this->breadcrumbs[$url_localidad] = $this->localidad_obj->getlocalidad();
							}
							
						}
					}
				}
				if (!empty($this->params_url_vars['usuario_newsletter'])){
					$item = new UsuarioNewsletter();
					$item->setid($_GET['id']);
					$item = $item->BuscarId();
					$url_item = $item->getLink();
					$this->breadcrumbs[$url_item] = SistemaIdioma::Imprimir($item->titulo);
				}
				
				break;
				
			case 'usuarios_newsletter':
				if (!empty($this->params_url_vars['categoria'])){
					$categoria = new ListaNewsletter();
					$categoria->setid($_GET['id']);
					$categoria = $categoria->BuscarId();
					$url_categoria = $categoria->getLink();
					$this->breadcrumbs[$url_categoria] = SistemaIdioma::Imprimir($categoria->nombre);
				}
				if ($params_ext["general"]["geolocalizacion_en_url"] == '1' && $params_ext["general"]["geolocalizacion"] == '1'){
					if (is_object($this->pais_obj)){
						$url_pais = $this->construir_url_categoria(true, array('pais'=>$this->pais_obj->iso2, 'provincia'=>'', 'localidad'=>''),true, $base_link);
						$this->breadcrumbs[$url_pais] = $this->pais_obj->getpais();
						
						if (is_object($this->provincia_obj)){
							$url_provincia = $this->construir_url_categoria(true, array('pais'=>$this->pais_obj->iso2, 'provincia'=>$this->provincia_obj->getalias(), 'localidad'=>''),true, $base_link);
							$this->breadcrumbs[$url_provincia] = $this->provincia_obj->getprovincia();
							
							if (is_object($this->localidad_obj)){
								$url_localidad = $this->construir_url_categoria(true, array('pais'=>$this->pais_obj->iso2, 'provincia'=>$this->provincia_obj->getalias(), 'localidad'=>$this->localidad_obj->getalias()),true, $base_link);
								$this->breadcrumbs[$url_localidad] = $this->localidad_obj->getlocalidad();
							}
							
						}
					}
				} elseif ($params_ext["general"]["geolocalizacion"] == '1') {
					if ($this->pais_obj = Pais::BuscarPorISO2($this->get_vars['pais'])){
						$url_pais = $this->construir_url_categoria(true, array('pais'=>$this->pais_obj->iso2, 'provincia'=>'', 'localidad'=>''),true, $base_link);
						$this->breadcrumbs[$url_pais] = $this->pais_obj->getpais();
						
						if ($this->provincia_obj = Provincia::BuscarAlias($this->get_vars['provincia'], $this->get_vars['pais'])){
							$url_provincia = $this->construir_url_categoria(true, array('pais'=>$this->pais_obj->iso2, 'provincia'=>$this->provincia_obj->getalias(), 'localidad'=>''),true, $base_link);
							$this->breadcrumbs[$url_provincia] = $this->provincia_obj->getprovincia();
							
							if ($this->localidad_obj = Localidad::BuscarAlias($this->get_vars['localidad'], $this->provincia_obj->id)){
								$url_localidad = $this->construir_url_categoria(true, array('pais'=>$this->pais_obj->iso2, 'provincia'=>$this->provincia_obj->getalias(), 'localidad'=>$this->localidad_obj->getalias()),true, $base_link);
								$this->breadcrumbs[$url_localidad] = $this->localidad_obj->getlocalidad();
							}
							
						}
					}
				}
				/*if (!empty($this->get_vars['anyo'])){
					$this->breadcrumbs[$this->current_url.'/?anyo='.$this->get_vars['anyo']] = $this->get_vars['anyo'];
					if (!empty($this->get_vars['mes'])){
						$this->breadcrumbs[$this->current_url.'/?anyo='.$this->get_vars['anyo'].'&mes='.$this->get_vars['mes']] = Helpers::getNombreMes($this->get_vars['mes']);
					}
				}*/
				
				break;
		}
		
		if (!empty($this->breadcrumbs)){
			$GLOBALS['AppDoc']->breadcrumbs = array_merge($GLOBALS['AppDoc']->breadcrumbs, $this->breadcrumbs);
		} else {
			parent::set_breadcrumbs();
		}
	}
		
	public function get_num_newsletters($filtro=''){
		
		$num_eve = new CampNewsletter();
		
		$num_eve = $num_eve->ListarCount($filtro);
		
		return $num_eve;
	}
}